# Data Extraction and charting with Pandas by using NSE Data
#www.Tricks12345.com   Program last updated: June 21, 2018.
import pandas as pd
from flask import Flask, render_template,request
from selenium import webdriver
from selenium.webdriver.common.action_chains import ActionChains
import time
from flask import Flask, render_template,request
import tkinter
from tkinter import messagebox
tk = tkinter.Tk()
tk.withdraw()
################################################################
driver = webdriver.Chrome()
driver.maximize_window()
totalrows = []
headerdata = []; bodydata = []; rowsdata = []; indexdata = []
url = 'https://www.nseindia.com'
driver.get(url)
time.sleep(3)
menu = driver.find_element_by_css_selector('#main_livemkt')
submenu =  driver.find_element_by_css_selector('#main_livemkt #main_livewth_stkwth')
ActionChains(driver).move_to_element(menu).click(submenu).perform()
time.sleep(3)
driver.current_window_handle          
totalrows = driver.find_element_by_id('dataTable').find_elements_by_tag_name('tr')
rowcount = len(driver.find_element_by_id('dataTable').find_elements_by_tag_name('tr'))        
for row in  totalrows:
             rowdata = []
             for c,col in enumerate(row.find_elements_by_tag_name('td') or row.find_elements_by_tag_name('th')):
                if c  == 1 or c  == 2 or c  == 13 or c  == 15:
                        continue
                if col.tag_name  == 'th':                     
                    headerdata.append(col.text)
                if col.tag_name  == 'td':
                     if c >= 3:
                          z = col.text.replace(',','')
                          rowdata.append(float(z))
                     else: rowdata.append(col.text)                    
             bodydata.append(tuple(rowdata))
rowsdata = bodydata[2:]
colscount = len(headerdata)
driver.close()
time.sleep(2)
messagebox.showinfo('Confirmation', 'Pavan now run the app')
indexdata = []
for i in range(len(rowsdata)):
     indexdata.append(rowsdata[i][0])
print('this is index data')
print(indexdata)
print('this is data frame')
print(rowsdata)
print(headerdata)
df = pd.DataFrame(rowsdata, columns = headerdata )
print(df)
################################################################
# for df1 considered symbols as index data
df1 = pd.DataFrame(rowsdata, columns = headerdata, index = indexdata )
q = list(df.shape)
rowscount = q[0]
colscount = q[1]
app = Flask(__name__)
@app.route('/') 
def index():
     return render_template('Pandas_Introduction.html')

#####Create DataFrame ##########################
@app.route('/CreateDataFrame')
def  CreateDataFrame():
       return render_template('Pandas_Create_DataFrame.html', headerdata = df.columns,\
                              totalrows = df.values,colscount = colscount, rowscount = rowscount)
#####Basics of DataFrame ##########################
@app.route('/Basics')
def  Basics():
     rowsandcolumns = list(df.shape)
     rows = rowsandcolumns[0]
     columns = rowsandcolumns[1]
     colscount = len(df.columns)
     columnHeaders = list(df.columns)
     values = df.values     
     rowindexrange = df.index   # returns row index range start to end in data frame     
     rowIndexInList = df.index.tolist() # print row indexes in a list
     NumberOfRows = len(df)
     cols = df.columns
     TotalColumnInList = df.columns.tolist()      
     columnheader = df.columns[0]
     colobj = df['Symbol'] # returns column as object
     columnsInlist = df[['Symbol']] # returns column as list   
     return render_template('Pandas_Basics.html', rowsandcolumns = rowsandcolumns, rows = rows,\
                            columns = columns, columnHeaders = columnHeaders, values = values,\
                            colscount = colscount, rowindexrange = rowindexrange, rowIndexInList = rowIndexInList,\
                            NumberOfRows = NumberOfRows, cols = cols, TotalColumnInList = TotalColumnInList,\
                            columnheader = columnheader, colobj = colobj,columnsInlist = columnsInlist)
#####Working with head ################################  
@app.route('/Head')
def  Head():      
     bodydata = df.head() # To print top 5 rows
     TopTenRows = df.head(10) # To print Top Ten Rows
     maxcolumn = 6
     return render_template('Pandas_Head.html', rowscount = 5, colscount =colscount,\
                            totalrows = bodydata.values, headerdata = df.columns,\
                            tenrows = TopTenRows.values, rows = 10, maxcolumn = 6)
#####Working with tail #################################  
@app.route('/Tail')
def  Tail():
     print(df.tail())
     bodydata = df.tail() # To print bottom 5 rows
     BottomTenRows = df.tail(10) # To print bottom Ten Rows
     maxcolumn = 6
     return render_template('Pandas_Tail.html', rowscount = 5, colscount =colscount,\
                            totalrows = bodydata.values, headerdata = df.columns,\
                            tenrows = BottomTenRows.values, rows = 10, maxcolumn = 6)
#####Working with iloc ######################################
@app.route('/iloc')
def  iloc():
      #print(df.iloc[0:4]) # prints only 1,2,3(exclusive of 4)
      Sevenrows =  df.iloc[1:8] # chage the slicing number as per your requirement
      p = list(Sevenrows.shape)
      #print(p)
      allrows =  df.iloc[:] # Print all rows from dataframe
      a = list(allrows.shape)
      rowscols =  df.iloc[1:8, 2:5] # print seven rows and five colums
      q = list(rowscols.shape)
      reqrows = df.iloc[[1,8,4,3,11,2,0]] # print required rows, we can change the row order also
      z = list(reqrows.shape)      
      #print(reqrows)
      return render_template('Pandas_Selection_Of_DataFrame_iloc.html',\
                         rowscount = p[0], colscount =p[1],totalrows = Sevenrows.values, headerdata = df.columns,\
                         r = a[0], rows = allrows.values,\
                         row = q[0], col = q[1], values = rowscols.values, head = rowscols.columns,\
                         rcount = z[0], v =reqrows.values)

#####Working with loc ######################################
@app.route('/loc')
def  loc():
      print(df1)
      # before executing the make sure these company symbols exists in 50 list
      df2 = df1.loc['GAIL':'MARUTI' ,'Symbol':'Chng']
      print(df2)
      z = list(df2.shape)
      #print(z)
      #print(df2.values)
      return render_template('Pandas_Selection_Of_DataFrame_loc.html',\
                             rowscount = z[0], colscount =z[1], totalrows = df2.values,\
                             headerdata = df2.columns)
#####Working with ix ######################################
@app.route('/ix')
def  ix():
      print(df.ix[0:11,'Symbol':'Chng'])
      tab =  df.ix[0:11,'Symbol':'Chng']
      z = list(tab.shape)      
      return render_template('Pandas_Selection_Of_DataFrame_ix.html',\
                             rowscount = z[0], colscount = z[1], totalrows = tab.values, headerdata = tab.columns)

#####Working with rows of DataFrame ##########################  
@app.route('/Rows')
def  Rows():      
      FirstTwoRows = df[0:2]
      rc = list(FirstTwoRows.shape)      
      thirdrow = df[::3]       
      third = list(thirdrow.shape)                 
      return render_template('Pandas_Rows_Indexes.html', headerdata = df.columns,\
                             FirstTwo = FirstTwoRows.values, rowscount = rc[0], colscount = rc[1],\
                             Everythird = thirdrow.values, r = third[0])
#####Working with columns of DataFrame ##########################  
@app.route('/Columns')
def  Columns():
    firstcolumnheader = df.columns[0] # to print the single column header
    singlecolumn = df.Symbol # to print the single column
    ColumnInList = df[['Symbol']]         
    MultiCols = (df[['Symbol', 'High']])
    z = list(MultiCols.shape)     
    reqcolumns=[1,7,3,5] #required columns irrespective of order of headers
    multiplecols = df[df.columns[[reqcolumns]]] # We can change the columns order as per our requirement
    r = list(multiplecols.shape)    
    headings = df.columns[[reqcolumns]]
    print(headings)
 
    return render_template('Pandas_Columns_Labels.html', firstcolumnheader = firstcolumnheader,\
                           singlecolumn = singlecolumn, ColumnInList = ColumnInList, rowscount = z[0],\
                           ColsCount = z[1], totalrows = MultiCols.values, headerdata =MultiCols.columns,\
                           headings = headings, bodyvalues = multiplecols.values,CCount = r[1])
#####For Loop #########################################
@app.route('/forloop')
def  forloop():
     data = []; headdata = []
     for (rowindex, rowdata) in df.iterrows():
          if rowindex == 5 or rowindex == 6 or rowindex == 11:
                data.append(rowdata.values)                
     z = list(data)
     return render_template('Pandas_ForLoop.html', data=data, headerdata = df.columns,\
                            rowscount =len(z),colscount = len(z[0]), rowsdata = data )
#####isin ##############################################
@app.route('/isin')
def  isin():      
     reqrows = df[(df.index.isin([4,8,5,11,2]))]                       
     z = list(reqrows.shape)                  
     return render_template('Pandas_isin.html', headerdata = reqrows.columns,\
                            rowscount =z[0],colscount = z[1], rowsdata = reqrows.values )   
#####Filters ##############################################
@app.route('/Charting')
def  Charting():
    chartdata = df.ix[df.Open > 1000,['Symbol','Open']].head(5)
    z = (chartdata.shape)
    import matplotlib.pyplot as plt     
    plt.plot(chartdata['Symbol'],chartdata['Open'], label = 'Open Price > 1000',
             color = 'red', linewidth = 5, marker = 'o', markerfacecolor = 'blue', markersize = 11)
    plt.xlabel('Symbols')
    plt.ylabel('Open Price')
    plt.title('5 Companies having Open price > 1000 from the Top')
    plt.legend(loc = 'upper left')
    plt.savefig('./static/OpenPrice.png')
    plt.close()
    plt.close('all') 
    return render_template('Pandas_Charting.html', rowscount = z[0], colscount = z[1],\
                           totalrows =chartdata.values, headerdata = chartdata.columns )

#####Sorting  ##############################################
@app.route('/Sorting')
def  Sorting():
    df1 =df.sort_values(by = 'High')
    import matplotlib.pyplot as pl
    Barchartdata = df1.ix[df1.High > 1000,['Symbol','High']].head(6)
    v = (Barchartdata.shape)
    pl.bar(Barchartdata['Symbol'],Barchartdata['High'], color = 'r')
    pl.xlabel('Symbols')
    pl.ylabel('High Price')
    pl.title('Top 6 Companies of High Price')
    pl.legend(loc = 'upper left')
    pl.savefig('./static/TopSixCompaniesOfHighPrice.png')
    pl.close()
    return render_template('Pandas_Sorting.html', rowscount = v[0], colscount = v[1],\
                           totalrows =Barchartdata.values, headerdata = Barchartdata.columns )

#####Filter  ##############################################
@app.route('/Filter')
def  Filter():    
    import matplotlib.pyplot as plt
    PiechartData =df.filter(items=['Symbol', 'LTP']).head(6)
    q = (PiechartData.shape)
    colrs = ['k','g','r','b', 'y','c']
    exp  = (0,0,0.1,0,0,0.05)
    plt.pie(PiechartData['LTP'], labels=PiechartData['Symbol'], colors=colrs, explode = exp)
    plt.title('LTP Data of 6 companies')
    plt.legend(loc = 'upper right')
    plt.savefig('./static/TopSixCompaniesOfLTP.png')
    plt.close()     
    return render_template('Pandas_Filter.html', rowscount = q[0], colscount = q[1],\
                           totalrows =PiechartData.values, headerdata = PiechartData.columns )

app.run(host = 'localhost', port = 5000)
